// Controlling a 2 servo arm using a Parallax 2-axis joystick
// by Matthew Matz

#include <Servo.h>

Servo myservo1;  // create servo object to control a servo
Servo myservo2;  // create servo object to control a servo

int joyX, joyY;
double servo1 = 1500, servo2 = 1500;

void setup()
{
  myservo1.attach(13);  // attaches the servo on pin 13 to the servo object
  myservo2.attach(12);  // attaches the servo on pin 12 to the servo object
  delay(2500);
}

void loop()
{
  joyX = analogRead(A1);            // reads the value of the potentiometer (value between 0 and 1023)
  joyY = analogRead(A0);            // reads the value of the potentiometer (value between 0 and 1023)

  //Lots of if statements to give the joystick a deadband and reasonable XY response

  if (joyX < 25) joyX = -10;
  if (joyX >= 25 && joyX < 50 ) joyX = -9;
  if (joyX >= 50 && joyX < 75 ) joyX = -8;
  if (joyX >= 75 && joyX < 100 ) joyX = -7;
  if (joyX >= 100 && joyX < 125 ) joyX = -6;
  if (joyX >= 125 && joyX < 150 ) joyX = -5;
  if (joyX >= 150 && joyX < 200 ) joyX = -4;
  if (joyX >= 200 && joyX < 250 ) joyX = -3;
  if (joyX >= 250 && joyX < 300 ) joyX = -2;
  if (joyX >= 300 && joyX < 375 ) joyX = -1;
  if (joyX >= 375 && joyX < 575 ) joyX = 0;
  if (joyX >= 575 && joyX < 650 ) joyX = 1;
  if (joyX >= 650 && joyX < 725 ) joyX = 2;
  if (joyX >= 725 && joyX < 775 ) joyX = 3;
  if (joyX >= 775 && joyX < 825 ) joyX = 4;
  if (joyX >= 825 && joyX < 875 ) joyX = 5;
  if (joyX >= 875 && joyX < 900 ) joyX = 6;
  if (joyX >= 900 && joyX < 925 ) joyX = 7;
  if (joyX >= 925 && joyX < 950 ) joyX = 8;
  if (joyX >= 950 && joyX < 975 ) joyX = 9;
  if (joyX >= 975) joyX = 10;

  if (joyY < 25) joyY = -10;
  if (joyY >= 25 && joyY < 50 ) joyY = -9;
  if (joyY >= 50 && joyY < 75 ) joyY = -8;
  if (joyY >= 75 && joyY < 100 ) joyY = -7;
  if (joyY >= 100 && joyY < 125 ) joyY = -6;
  if (joyY >= 125 && joyY < 150 ) joyY = -5;
  if (joyY >= 150 && joyY < 200 ) joyY = -4;
  if (joyY >= 200 && joyY < 250 ) joyY = -3;
  if (joyY >= 250 && joyY < 300 ) joyY = -2;
  if (joyY >= 300 && joyY < 375 ) joyY = -1;
  if (joyY >= 375 && joyY < 575 ) joyY = 0;
  if (joyY >= 575 && joyY < 650 ) joyY = 1;
  if (joyY >= 650 && joyY < 725 ) joyY = 2;
  if (joyY >= 725 && joyY < 775 ) joyY = 3;
  if (joyY >= 775 && joyY < 825 ) joyY = 4;
  if (joyY >= 825 && joyY < 875 ) joyY = 5;
  if (joyY >= 875 && joyY < 900 ) joyY = 6;
  if (joyY >= 900 && joyY < 925 ) joyY = 7;
  if (joyY >= 925 && joyY < 950 ) joyY = 8;
  if (joyY >= 950 && joyY < 975 ) joyY = 9;
  if (joyY >= 975) joyY = 10;


  servo1 = servo1 - (9 * joyX - 2 * joyY) / 6;  // Simplified linear approximations of the 
  servo2 = servo2 + joyY - 4 * joyX / 3;        // Inverse Kinematics for a 2 joint Arm:
                                                // Movement is approximately linear if you stay 
                                                // within a single quadrant.
                                                // Some trig functions here would draw straighter
                                                // lines, but what fun is that?


  servo1 = constrain(servo1, 600, 2200);      // Keep the variables within the servos' range
  servo2 = constrain(servo2, 600, 2200);


  myservo1.writeMicroseconds((int) servo1);
  myservo2.writeMicroseconds((int) servo2);
  delay(10);                           // waits for the servo to get there
}
